(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require bool.Bool.

Axiom a : Type.
Parameter a_WhyType : WhyType a.
Existing Instance a_WhyType.

Parameter atom: a -> Prop.

(* Why3 assumption *)
Inductive p :=
  | A : a -> p
  | AND : p -> p -> p
  | OR : p -> p -> p
  | NOT : p -> p
  | T : p
  | F : p.
Axiom p_WhyType : WhyType p.
Existing Instance p_WhyType.

(* Why3 assumption *)
Fixpoint sem (f:p) {struct f}: Prop :=
  match f with
  | T => True
  | F => False
  | (A a1) => (atom a1)
  | (AND u v) => (sem u) /\ (sem v)
  | (OR u v) => (sem u) \/ (sem v)
  | (NOT u) => ~ (sem u)
  end.

(* Why3 assumption *)
Definition imply (u:p) (v:p): Prop := (sem u) -> (sem v).

Parameter select: a -> bool.

Parameter filter: bool -> p -> p.

Axiom filter_def : forall (polarity:bool) (f:p),
  match f with
  | T => ((filter polarity f) = T)
  | F => ((filter polarity f) = F)
  | (A a1) => (((select a1) = true) -> ((filter polarity f) = (A a1))) /\
      ((~ ((select a1) = true)) -> (((polarity = true) -> ((filter polarity
      f) = F)) /\ ((~ (polarity = true)) -> ((filter polarity f) = T))))
  | (AND p1 q) => ((filter polarity f) = (AND (filter polarity p1)
      (filter polarity q)))
  | (OR p1 q) => ((filter polarity f) = (OR (filter polarity p1)
      (filter polarity q)))
  | (NOT p1) => ((~ (polarity = true)) -> ((filter polarity
      f) = (NOT (filter true p1)))) /\ ((polarity = true) ->
      ((filter polarity f) = (NOT (filter false p1))))
  end.

(* Why3 assumption *)
Definition filtering (f:p): Prop := (imply (filter true f) f) /\ (imply f
  (filter false f)).

Axiom f_true : (filtering T).

Axiom f_false : (filtering F).

Axiom f_atom : forall (a1:a), (filtering (A a1)).

Axiom f_not : forall (p1:p), (filtering p1) -> (filtering (NOT p1)).

Axiom f_and : forall (p1:p) (q:p), (filtering p1) -> ((filtering q) ->
  (filtering (AND p1 q))).

Axiom f_or : forall (p1:p) (q:p), (filtering p1) -> ((filtering q) ->
  (filtering (OR p1 q))).

(* Why3 goal *)
Theorem filtering1 : forall (p1:p), (filtering p1).
(* Why3 intros p1. *)
intros p.
induction p.
 - apply f_atom.
 - apply f_and ; auto.
 - apply f_or ; auto.
 - apply f_not ; auto.
 - apply f_true.
 - apply f_false.
Qed.


